#ifndef CONNECTOR_H
#define CONNECTOR_H

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <qwidget.h>
#include <qstring.h>
#include <qlabel.h>
#include <qlistview.h>
#include <qsizepolicy.h>
#include <qsize.h>
#include <qlistbox.h>
#include <jack/jack.h>

#define CONNECTOR_MINIMUM_WIDTH            100
#define CONNECTOR_MINIMUM_HEIGHT            50
#define MAX_PORTS                          256

enum connectorStyleType {CONNECTOR_STRAIGHT, CONNECTOR_BEZIER};

class Connector : public QWidget
{
  Q_OBJECT

  private:
    QObject *jackGui;

  protected:
    virtual void paintEvent(QPaintEvent *);
    virtual void resizeEvent (QResizeEvent* );            
    void arrow(int x1, int y1, int x2, int y2);
    
  public:
    Connector(QObject *jackGui, QWidget* parent=0, const char *name=0);
    virtual QSize sizeHint() const;
    virtual QSizePolicy sizePolicy() const;
    
  public slots: 
    void updateConnector();
    void move (int x, int y);
};
  
#endif
