#ifndef JACKGUI_H
#define JACKGUI_H

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <qwidget.h>
#include <qstring.h>
#include <qslider.h>   
#include <qcheckbox.h>  
#include <qstringlist.h>
#include <qlabel.h>
#include <qlist.h>
#include <qtimer.h>
#include <qframe.h>
#include <qhbox.h>
#include <qvbox.h>
#include <qmessagebox.h>
#include <qsocketnotifier.h>
#include <qpopupmenu.h>
#include <qscrollview.h>
#include <qlistbox.h>
#include <qlistview.h>
#include <qpoint.h>
#include <alsa/asoundlib.h>
#include "connector.h"
#include "jackport.h"
#include "jackclient.h"
#include "portitem.h"

#define DEFAULT_WIDTH             400
#define DEFAULT_HEIGHT            300

class JackGui : public QVBox
{
  Q_OBJECT

  private:
    jack_client_t *jack_handle;
    Connector *connector;
    QMessageBox *aboutWidget;
    QTimer *timer, *connectorTimer;
    int rate;
    float cpuload;
    bool ignoreChangeFlag, ignoreAnnounceFlag;

  public:
    QLabel *loadLabel, *rateLabel;
    QListView *readPorts, *writePorts;
    QList<JackClient> readClientList, writeClientList;
    
  public:
    JackGui(jack_client_t *p_jack_handle, QWidget* parent=0, const char *name=0);
 
  public slots: 
    void displayAbout();
    void refreshGui();
    void connectClicked();
    void disconnectClicked();
    void showAllClicked();
    void hideAllClicked();
    void closeJack();
    void jackAnnounce(int fd);
    void updatePortLists();
    void updateConnections();
    void listViewUpdate(QListViewItem *item);
};
  
#endif
